/* 
=================================================================================
 + 파일명 : ri-cookie.js
 + 버전: 1.0
 + 배포일 : 2022-11-21
 + 제작자 : R BLOG (lcy@redinfo.co.kr)
 + 기타   : (가이드 URL) https://blog.redinfo.co.kr/post/view?pid=153
            (블로그 URL) https://blog.redinfo.co.kr
=================================================================================
*/
if(typeof $ == 'undefined'){ var $ = {}; }
$.cookie = {
	/*쿠키변수*/
	$ : new Array(),
	/*기본옵션세팅*/
	defaultOption : {
		expires : 0,
		path : '/',
		domain : document.domain,
		secure : true,
		option : '',		
	},

	/*set파라미터의 쿠키옵션*/
	optionCheck : function(param){
		var $this = this;
		if( typeof param == 'undefined'){ return true; }
		if( typeof option == 'undefined' || !option){ return true; }
		var str = param+'='
		if( option.indexOf(str) >= 0){
			return false;
		}
		return true;
	},

	/*쿠키set*/
	set : function(name,value,expires, path, domain,secure,option){
		var $this = this;
		var set = new Array();

		if( typeof name == 'undefined'){ return false; }
		if( typeof value == 'undefined'){ value = ''; }
		name = name.trim();
		set.push(name+'='+value);	

		if( $this.optionCheck('expires') === true){ 
			if( typeof expires != 'number' || !expires ){ expires = $this.defaultOption.expires; }
			var date = new Date();
			if( expires > 0){
				var expiresTime = date.getTime()+(expires*1000);
				var expiresUTC = new Date(expiresTime).toUTCString();
			}
			else{
				var expiresUTC = 'Thu, 01 Jan 1970 00:00:01 GMT';
			}

			if( expires !== 0){
				set.push('expires='+expiresUTC);
			}
			
		}

		if( $this.optionCheck('path') === true){ 
			if(typeof path == 'undefined' || path == ''){ path = $this.defaultOption.path; }
			set.push('path='+path);
		}

		if( $this.optionCheck('domain') === true){ 
			if( typeof domain == 'undefined' || domain == ''){ domain = $this.defaultOption.domain; }
			set.push('domain='+domain);
		}

		/*크롬80 보완: https에서만 작동*/
		var https = document.URL.indexOf("https://");
		if( $this.optionCheck('SameSite') === true && $this.optionCheck('Secure') === true && https === 0 ){ 
			if( typeof secure == 'undefined' ){ secure = $this.defaultOption.secure; }
			if( typeof secure == 'boolean' && secure === true){
				set.push('SameSite=None; Secure');
			}
		}

		/*옵션 - 완벽지원 안됨*/
		if(typeof option != 'undefined' && option != ''){
			set.push(option);
		}

		var setCookie = set.join("; ").trim();
		document.cookie = setCookie;

		$this.update();

		return true;
	},

	/*쿠키가져오기*/
	get : function(name){
		var $this = this;
		$this.update();
		if(typeof name == 'undefined' || !name){ return false;  }
		name = name.trim();
		if(typeof $this.$[name] != 'undefined'){ return $this.$[name]; }
		return false;
	},

	/*쿠키삭제*/
	unset : function(name){
		var $this = this;
		if(typeof name == 'undefined' || !name){ return false;  }
		$this.set(name,'',-1);
		return true;
	},

	/*쿠키 전체비우기*/
	destory : function(){
		var $this = this;
		$this.update();
		if( Object.keys($this.$).length < 1){ return true; }
		Object.keys($this.$).forEach(function(name){
			$this.unset(name);
		});

		return true;
	},

	/*쿠키업데이트*/
	update : function(){
		var $this = this;
		$this.$ = new Array();
		var arrCookie = document.cookie.split(';');
		arrCookie.forEach(function(value){
			var kv = value.split('=');
			if( typeof kv[0] == 'undefined' || !kv[0].trim()){ return true; }
			$this.$[kv[0].trim()] = kv[1];
		});
		return true;
	}
};

